Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed Affected version: 3.4.6

Description

Currently projects API returns all trackers, assigned to given project. This is inconsistency with web view, which shows only trackers,

visible to the user. They are the only usable to current user anyways.

This is invoked like this: projects/PROJECTID.json?include=trackers

The problem is in redmine/app/helpers/projects_helper.rb, where the line:

project.trackers.each do |tracker|

should be changed to

project.trackers.visible.each do |tracker|

Related issues:

Related to Redmine - Feature #285: Tracker role-based permissioning Closed

Associated revisions

Revision 20753 - 2021-02-23 04:17 - Go MAEDA

Projects API should not return invisible trackers (#30121).

Patch by Yuichi HARADA.

History

#1 - 2018-12-08 01:12 - Go MAEDA

- Related to Feature #285: Tracker role-based permissioning added

#2 - 2018-12-08 09:47 - Go MAEDA

- Category set to REST API

#3 - 2018-12-08 09:56 - Go MAEDA

- Status changed from New to Confirmed

Confirmed the problem. Thank you for catching and reporting this.

#4 - 2018-12-13 02:53 - Yuichi HARADA

- File 30121-api-will-return-trackers-with-role-based.patch added

Alex Stanev wrote:

should be changed to

project.trackers.visible.each do |tracker|

 

I think that project.rolled_up_trackers(false).visible is better than project.trackers.visible .

I changed it as follows.

2025-07-11 1/2



diff --git a/app/helpers/projects_helper.rb b/app/helpers/projects_helper.rb

index 794546163..64d6fea83 100644

--- a/app/helpers/projects_helper.rb

+++ b/app/helpers/projects_helper.rb

@@ -115,7 +115,7 @@ module ProjectsHelper

   def render_api_includes(project, api)

     api.array :trackers do

-      project.trackers.each do |tracker|

+      project.rolled_up_trackers(false).visible.each do |tracker|

         api.tracker(:id => tracker.id, :name => tracker.name)

       end

     end if include_in_api_response?('trackers')

I made a patch, and attach it.

#5 - 2018-12-13 12:32 - Alex Stanev

Hi, thanks for you help!

This approach will also do the trick, can't test it right now.

Also maybe Go will require test for this.

#6 - 2019-02-03 16:54 - Marius BĂLTEANU

- Target version set to Candidate for next minor release

#7 - 2021-02-13 08:43 - vzvu 3k6k

LGTM. We (matobaa, sanak and me) have verified the following with trunk (revision 20744).

The bug reported in the issue has been fixed by your patch.

All tests are also successful.

In the patch, we noticed that the argument of rolled_up_trackers is false instead of Setting.display_subprojects_issues? as in

ProjectsController#show. We assume this is because the sub project trackers are probably not needed with this API.

#8 - 2021-02-21 05:38 - Go MAEDA

- Subject changed from Projects API should return only trackers, visible to the user to Projects API should not return invisible trackers

- Target version changed from Candidate for next minor release to 4.1.2

Setting the target version to 4.1.2.

#9 - 2021-02-23 04:18 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

Committed the patch. Thank you all for your contribution.

#10 - 2021-02-24 16:17 - Go MAEDA

- Status changed from Resolved to Closed

- Target version changed from 4.1.2 to 4.2.0

- Resolution set to Fixed

Files

30121-api-will-return-trackers-with-role-based.patch 2.06 KB 2018-12-13 Yuichi HARADA
